<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: データベース</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>データベース<br/>
<small>
[<a class="el" href="group__m17nCore.html">コア API</a>]</small>
</h1>
<p>m17n データベースにとそれに関する API.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>型定義</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">データベースの型宣言.  <a href="#ga185385212a1dcd2bbb8ec94ba31caf0e"></a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#gaf0b925b48cf03873cf8cdb7b81a3c37d">mdatabase_find</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag0, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag1, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag2, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag3)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">データベース中のデータを探す.  <a href="#gaf0b925b48cf03873cf8cdb7b81a3c37d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#gaf3db907393a30e6c1ea062691cb8a2b0">mdatabase_list</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag0, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag1, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag2, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag3)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">m17n データベースのデータリストを返す.  <a href="#gaf3db907393a30e6c1ea062691cb8a2b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d">mdatabase_define</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag0, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag1, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag2, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> tag3, void *(*loader)(<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *, void *), void *extra_info)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">m17n データベースのデータを定義する.  <a href="#ga265cfa2587dfda9bdc84f7afd1aabb1d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e">mdatabase_load</a> (<a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *mdb)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">データベースからデータをロードする.  <a href="#ga62e5cf92d1b2836a9f6a988bcc20c26e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#ga5362edb0cb91ff9c90d569d7aca58b39">mdatabase_tag</a> (<a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *mdb)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">データのタグを得る.  <a href="#ga5362edb0cb91ff9c90d569d7aca58b39"></a><br/></td></tr>
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDatabase.html#ga29022d6905ce43de1ac69cd1f88b36f7">mdatabase_dir</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">アプリケーション固有のデータ用ディレクトリ.  <a href="#ga29022d6905ce43de1ac69cd1f88b36f7"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>m17n データベースにとそれに関する API. </p>
<p>m17n ライブラリは必要に応じて動的に <em>m17n</em> <em>データベース</em> から情報を取得する。またアプリケーションプログラムも、独自のデータを m17n データベースに追加し、それを動的に取得することができる。 アプリケーションプログラムが独自のデータを追加・取得するには、変数 <a class="el" href="group__m17nDatabase.html#ga29022d6905ce43de1ac69cd1f88b36f7" title="アプリケーション固有のデータ用ディレクトリ.">mdatabase_dir</a> にそのアプリケーション固有のディレクトリをセットし、 その中にデータを格納する。ユーザがそのデータをオーバーライトしたい ときは、環境変数 "M17NDIR" で指定されるディレクトリ（指定されていな いときは "~/.m17n.d" というディレクトリ）に別のデータを置く。</p>
<p>m17n データベースには複数の多様なデータが含まれており、各データは TAG0, TAG1, TAG2, TAG3（すべてシンボル）の４つのタグによって識別される。</p>
<p>TAG0 によって、データベース内のデータのタイプは次のように指定される。</p>
<ul>
<li>TAG0 が <a class="el" href="group__m17nChartable.html#ga91e88555aace667aa53a16e5fbb4226c" title="&quot;char-table&quot; という名前を持つシンボル.">Mchar_table</a> であるデータは <em>chartableタイプ</em> と呼ばれ、各文字に関する情報を提供する。この場合 TAG1 は情報の種類を指定するシンボルであり、<a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="&quot;symbol&quot; を名前として持つシンボル.">Msymbol</a>, <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8" title="&quot;integer&quot; を名前として持つシンボル.">Minteger</a>, <a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5" title="&quot;string&quot; を名前として持つシンボル.">Mstring</a>, <a class="el" href="group__m17nPlist.html#ga1a22859374071a0ca66f12452afee8bd" title="&quot;mtext&quot; を名前として持つシンボル.">Mtext</a>, <a class="el" href="group__m17nPlist.html#ga933000e154873f9bfcaa56d976bd259b" title="&quot;plist&quot; を名前として持つシンボル.">Mplist</a> のいずれかである。TAG2 と TAG3 は任意のシンボルでよい。</li>
</ul>
<ul>
<li>TAG0 が <a class="el" href="group__m17nCharset.html#ga45426542709f174689a06ce7c34a37de" title="シンボル Mcharset.">Mcharset</a> であるデータは <em>charsetタイプ</em> と呼ばれ、文字セット用のデコード／エンコードマップを提供する。この場合 TAG1 は文字セットのシンボルでなければならない。TAG2 と TAG3 は任意のシンボルでよい。</li>
</ul>
<ul>
<li>TAG0 が <a class="el" href="group__m17nChartable.html#ga91e88555aace667aa53a16e5fbb4226c" title="&quot;char-table&quot; という名前を持つシンボル.">Mchar_table</a> でも <a class="el" href="group__m17nCharset.html#ga45426542709f174689a06ce7c34a37de" title="シンボル Mcharset.">Mcharset</a> でもない場合、そのデータは <em>plistタイプ</em> である。詳細に関しては関数 <a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a> の説明を参照のこと。この場合 TAG1、TAG2、TAG3 は任意のシンボルでよい。</li>
</ul>
<p>特定のタグを持つデータベースを &lt;TAG0, TAG1, TAG2, TAG3&gt; という形式で表す。</p>
<p>アプリケーションプログラムは、まず関数 <a class="el" href="group__m17nDatabase.html#gaf0b925b48cf03873cf8cdb7b81a3c37d" title="データベース中のデータを探す.">mdatabase_find()</a> を使ってデータベースに関する情報を保持するオブジェクト（<a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e" title="データベースの型宣言.">MDatabase</a> 型）へのポインタを得る。それに成功したら、 <a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a> によって実際にデータベースをロードする。構造体 <a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e" title="データベースの型宣言.">MDatabase</a> 自身がどう実装されているかは、アプリケーションプログラムからは見えない。</p>
 <hr/><h2>型定義</h2>
<a class="anchor" id="ga185385212a1dcd2bbb8ec94ba31caf0e"></a><!-- doxytag: member="m17n&#45;core.h::MDatabase" ref="ga185385212a1dcd2bbb8ec94ba31caf0e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> <a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>データベースの型宣言. </p>
<p><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e" title="データベースの型宣言.">MDatabase</a> 型はデータベースオブジェクト用の構造体である。 内部構造はアプリケーションプログラムからは見えない。 </p>

</div>
</div>
<hr/><h2>関数</h2>
<a class="anchor" id="gaf0b925b48cf03873cf8cdb7b81a3c37d"></a><!-- doxytag: member="database.c::mdatabase_find" ref="gaf0b925b48cf03873cf8cdb7b81a3c37d" args="(MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a>* mdatabase_find </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag3</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>データベース中のデータを探す. </p>
<p>関数 <a class="el" href="group__m17nDatabase.html#gaf0b925b48cf03873cf8cdb7b81a3c37d" title="データベース中のデータを探す.">mdatabase_find()</a> は、 m17n 言語情報ベース中で <b>tag0</b> から <b>tag3</b> までのタグを持つデータを探し、それへのポインタを返す。そのようなデータがなければ <code>NULL</code> を返す。</p>
 
</div>
</div>
<a class="anchor" id="gaf3db907393a30e6c1ea062691cb8a2b0"></a><!-- doxytag: member="database.c::mdatabase_list" ref="gaf3db907393a30e6c1ea062691cb8a2b0" args="(MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mdatabase_list </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag3</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>m17n データベースのデータリストを返す. </p>
<p>関数 <a class="el" href="group__m17nDatabase.html#gaf3db907393a30e6c1ea062691cb8a2b0" title="m17n データベースのデータリストを返す.">mdatabase_list()</a> は m17n データベース中から <b>tag0</b> から<b>tag3</b> までのタグを持つデータを探し、そのリストをplist として返す。 <b>tagn</b> が <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> であった場合には、任意のタグにマッチするワイルドカードとして取り扱われる。返される plist の各要素はキー として <a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f" title="&quot;t&quot; を名前として持つシンボル.">Mt</a> を、値として <a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e" title="データベースの型宣言.">MDatabase</a> 型へのポインタを持つ。 </p>

</div>
</div>
<a class="anchor" id="ga265cfa2587dfda9bdc84f7afd1aabb1d"></a><!-- doxytag: member="database.c::mdatabase_define" ref="ga265cfa2587dfda9bdc84f7afd1aabb1d" args="(MSymbol tag0, MSymbol tag1, MSymbol tag2, MSymbol tag3, void *(*loader)(MSymbol *, void *), void *extra_info)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a>* mdatabase_define </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>tag3</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *(*)(<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *, void *)&nbsp;</td>
          <td class="paramname"> <em>loader</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>extra_info</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>m17n データベースのデータを定義する. </p>
<p>関数 <a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d" title="m17n データベースのデータを定義する.">mdatabase_define()</a> は <b>tag0</b> から <b>tag3</b> までのタグおよび付加情報 <b>extra_info</b> を持つデータを定義する。</p>
<p><b>loader</b> はそのデータのロードに用いられる関数へのポインタである。この関数は <a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a> から <b>tags</b> と <b>extra_info</b> という二つの引数付きで呼び出される。ここで <b>tags</b> は <b>tag0</b> から <b>tag3</b> までの配列である。</p>
<p>もし <b>loader</b> が <code>NULL</code> なら、m17n ライブラリ標準のローダが使われる。この場合には <b>extra_info</b> はデータを含むファイル名でなくてはならない。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理に成功すれば <a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d" title="m17n データベースのデータを定義する.">mdatabase_define()</a> は定義されたデータベースへのポインタを返す。このポインタは関数 <a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a> の引数として用いることができる。そうでなければ <code>NULL</code> を返す。</dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a>, <a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d" title="m17n データベースのデータを定義する.">mdatabase_define()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga62e5cf92d1b2836a9f6a988bcc20c26e"></a><!-- doxytag: member="database.c::mdatabase_load" ref="ga62e5cf92d1b2836a9f6a988bcc20c26e" args="(MDatabase *mdb)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mdatabase_load </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *&nbsp;</td>
          <td class="paramname"> <em>mdb</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>データベースからデータをロードする. </p>
<p>関数 <a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a> は <b>mdb</b> が指すデータをロードし、その中身を返す。返されるものはデータのタイプによって異なる。</p>
<p>データが <em>plistタイプ</em> ならば、 <em>plist</em> へのポインタを返す。</p>
<p>データが <em>chartableタイプ</em> ならば文字テーブルを返す。 文字テーブルのデフォルト値は、データの第2タグによって以下のように決まる。</p>
<ul>
<li>タグが <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="&quot;symbol&quot; を名前として持つシンボル.">Msymbol</a> なら、デフォルト値は <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> </li>
<li>タグが <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8" title="&quot;integer&quot; を名前として持つシンボル.">Minteger</a> なら、デフォルト値は -1 </li>
<li>それ以外なら、デフォルト値は <code>NULL</code> </li>
</ul>
<p>データが <em>charsetタイプ</em> ならば長さ 2 の plist を返す（キーは共に<a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f" title="&quot;t&quot; を名前として持つシンボル.">Mt</a> ）。 最初の要素の値はコードポイントを対応する文字コードにマップする整数の配列である。 ２番目の要素の値は逆のマップをする文字テーブルである。 この文字セットは予め定義されていなければならない。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nDatabase.html#ga62e5cf92d1b2836a9f6a988bcc20c26e" title="データベースからデータをロードする.">mdatabase_load()</a>, <a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d" title="m17n データベースのデータを定義する.">mdatabase_define()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga5362edb0cb91ff9c90d569d7aca58b39"></a><!-- doxytag: member="database.c::mdatabase_tag" ref="ga5362edb0cb91ff9c90d569d7aca58b39" args="(MDatabase *mdb)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>* mdatabase_tag </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nDatabase.html#ga185385212a1dcd2bbb8ec94ba31caf0e">MDatabase</a> *&nbsp;</td>
          <td class="paramname"> <em>mdb</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>データのタグを得る. </p>
<p>関数 <a class="el" href="group__m17nDatabase.html#ga5362edb0cb91ff9c90d569d7aca58b39" title="データのタグを得る.">mdatabase_tag()</a> は、データ <b>mdb</b> のタグ（シンボル）の配列を返す。配列の長さは 4 である。</p>
 
</div>
</div>
<hr/><h2>変数</h2>
<a class="anchor" id="ga29022d6905ce43de1ac69cd1f88b36f7"></a><!-- doxytag: member="database.c::mdatabase_dir" ref="ga29022d6905ce43de1ac69cd1f88b36f7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* <a class="el" href="group__m17nDatabase.html#ga29022d6905ce43de1ac69cd1f88b36f7">mdatabase_dir</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>アプリケーション固有のデータ用ディレクトリ. </p>
<p>アプリケーションプログラムが、そのプログラム固有のデータや m17n データベースを上書きするデータを提供する場合には、マクロ <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="m17n ライブラリを初期化する.">M17N_INIT()</a> を呼ぶ前にこの変数をデータファイルを含むディレクトリ名にセットしなくてはならない。ディレクトリには "mdb.dir" ファイルをおくことができる。その"mdb.dir"ファイルには、 <a class="el" href="m17nDBFormat.html#mdbDir">mdbDir(5)</a> で説明されているフォーマットでデータ定義のリストを記述する。</p>
<p>デフォルトの値は NULL である。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
